# Fraktalism

## Iterative computing inside !

Voyons d'abord
[une vidéo](http://la.buvette.org/fractales/f90/video.html)
qui montre ma première expérience dans ce domaine.

## La technique

Le gros des calculs de fractales est fait dans `mods/fraktals.f90`,
et la gestion des pixels 'physiques' est faite par les
modules externes `spitpgm` et `pixrgb`.

Les fonctions d'usage général sont dans
[mods/](répertoire mods/) ave trop peu
[d'explications](mods/documentation.md)

Des scripts _shell_ sont utilisés pour construire les vidéos.

## File Formats

Certains programmes enregistrent des tables de points 3d dans
des fichiers.

```
  type t_point3d
    double precision      :: x, y, z
    integer               :: seq
  end type t_point3d
```

Generally writen as a *sequencial unformated* file.

## TODO

- Voir de près le calcul du cadrage 
- Rajouter des formules
- Ne pas procastiner sur le reste

## See also

- https://www.maths.town/fractal-articles/mandelbulb/mandelbulb-all-powers/
- https://discuss.pixls.us/t/intriguing-shapes-in-buddhabrot-like-fractals/41816
