#!/bin/bash

#
#	build the prog
#

make mkjulia
if [ $? -ne 0 ] ; then
	echo
	echo "Make error " $?
	exit 1
fi

#
#	run the prog
#
workdir="frames/julia/"
for foo in $(seq 0 179)
do

	img=$(printf "%s/%05d.pnm" $workdir $foo)
	bar=$(echo "$foo / 247.0"			| bc -l)
	cx=$(echo "0.5 * (1.52*c($foo/28.0))"		| bc -l)
	cy=$(echo "0.5 * (1.45*s($foo/17.0))"		| bc -l)

	./mkjulia $img $cx $cy

	sleep 145

done

./tagpicz.sh $workdir

echo ; echo "Encoding, please wait..."

convert -delay 10 $workdir/*.pnm color-julia.gif
# animate foo.gif &

